<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>ToDoList</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet"
          integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">
    <style>
        body {
            font-family: Arial, Helvetica, sans-serif;
        }

        h1 {
            font-weight: bold;
        }

        #input-todo {
            width: 100%;
            margin: 10px 0 10px;
        }

        .todo {
            width: 100%;
            margin: 5px 0 5px;
        }

        .check-box {
            margin: 5px 0 5px;
        }

        #submit-todo {
            margin: 10px 0 10px;
        }

        #error-msg {
            color: red;
        }
        .line-though {
            text-decoration: line-through;
        }

        #delete-button {
            cursor: pointer;
        }
    </style>
</head>
<body>
<div class="container">
    <h1>To do list</h1>
    <div class="row">
        <div class="col-8">
            <input type="text" id="input-todo" name="input-todo" placeholder="Input todo">
            <div id="error-msg"></div>
        </div>

        <div class="col-4">
            <input type="submit" id="submit-todo" value="Submit" onclick="addToDoItem()">
        </div>
    </div>

    <div id="empty-msg"></div>

    <div id="toDoElements"></div>
</div>

<script>
    document.getElementById("submit-todo").addEventListener("click", function(event) {
        event.preventDefault()
    });

    document.addEventListener("keydown", function(event) {
        if (event.key === 'Enter') {
            addToDoItem()
        }
    });

    // List of Objects
    // Get from localStorage
    let list = getTodoItemList();
    let counter = getCounter();
    refreshList();

    // Call API to get TOdolist from Server
    function getTodoItemList() {
        // get todo item list from local storage.
        const list = localStorage.getItem('TODO_ITEM_LIST');
        if (list === null) {
            return []
        } else {
            // convert String => Array
            return JSON.parse(list);
        }
    }
    
     // Call API to get Counter from Server
    function getCounter() {
        const counter = localStorage.getItem('TODO_ITEM_COUNTER');
        if (counter === null) {
            return 0;
        } else {
            // convert string => number
            return parseInt(counter);
        }
    }
    
    // Call API to send list to server
    function saveTodoItemList() {
        localStorage.setItem('TODO_ITEM_LIST', JSON.stringify(list));
    }

    // Call API to send counter to server
    function saveCounter() {
        localStorage.setItem('TODO_ITEM_COUNTER', JSON.stringify(counter));
    }

    function addToDoItem() {
        const todoInputElement = document.getElementById("input-todo");
        const todoInputValue = todoInputElement.value;
        if (todoInputValue.trim().length === 0) {
            document.getElementById('error-msg').innerHTML = 'Input is required.';
            return;
        } else {
            document.getElementById('error-msg').innerHTML = '';
        }
        list.push({
            todo: todoInputValue,
            done: false,
            counterNumber: counter,
            createdAt: new Date()
        });
        counter++;
        saveCounter();
        saveTodoItemList();
        todoInputElement.value = "";
        refreshList();
    }

    function removeToDoItem(counterNumber) {
        for (let i = 0; i < list.length; i++) {
            if (list[i].counterNumber === counterNumber) {
                list.splice(i, 1);
                break;
            }
        }
        saveTodoItemList();
        refreshList();
    }

    function editToDoItem(event, counterNumber) {
        console.log(event)
        let edited = event.target.value;
        for (let item of list) {
            if (item.counterNumber === counterNumber) {
                item.todo = edited;
                break;
            }
        }
        saveTodoItemList();
        refreshList();
    }

    function refreshList() {
        let toDoElements = "";
        for (let item of list) {
            toDoElements = toDoElements + `
                <div class="row">
                    <div class="col-1 d-flex align-items-center justify-content-center">
                        <input id="done-checkbox-${item.counterNumber}" type="checkbox" ${item.done ? 'checked' : ''}
                         class="check-box" onchange="onDoneCheckBoxChange(event, ${item.counterNumber})">
                    </div>

                    <div class="col-1 d-flex align-items-center justify-content-center">
                        <span id="delete-button" onclick="removeToDoItem(${item.counterNumber})">X</span>
                    </div>
            
                    <div class="col-10">
                        <input type="text" class="todo ${item.done ? 'line-though': ''}" value="${item.todo}" onchange="editToDoItem(event, ${item.counterNumber})" >
                    </div>
                </div>
            `;
        }
        if (list.length === 0) {
            document.getElementById('empty-msg').innerHTML = 'Your to do list is empty!';
        } else {
            document.getElementById('empty-msg').innerHTML = '';
        }
        document.getElementById("toDoElements").innerHTML = toDoElements;
    }

    function onDoneCheckBoxChange(event, counterNumber) {
        // Catch event onChange done-checkbox
        console.log(event)
        // event => checkbox checked ? unchecked
        let checked = event.target.checked;
        // counterNumber => todo item
        // update todo item {done : checked ? unchecked}
        for (let item of list) {
            if (item.counterNumber === counterNumber) {
                item.done = checked;
                item.doneAt = new Date();
                break;
            }
        }
        const doneItems = [];
        const undoneItems = [];
        for (let item of list) {
            if (item.done) {
                doneItems.push(item);
            } else {
                undoneItems.push(item);
            }
        }
        doneItems.sort(function (a, b) {
            return b.doneAt - a.doneAt
        });
        undoneItems.sort(function (a, b) {
            return a.createdAt - b.createdAt
        });
        list = [
            ...undoneItems,
            ...doneItems
        ]
        saveTodoItemList();
        refreshList();
    }

</script>

</body>
</html>